/*********************************************************************************************************//**
 * @file    pt32z192xx_serial.c
 * @version V1.00
 * @date    07/07/2017
 * @brief   This file provides all the Low level serial routines for pangu01
 *************************************************************************************************************

 ************************************************************************************************************/

/* Includes ------------------------------------------------------------------------------------------------*/
#include "pt32z192xx.h"



/** @defgroup SERIAL SERIAL
  * @brief Serial related functions
  * @{
  */

/*********************************************************************************************************//**
 * @brief  Put char to UART.
 * @param  ch: The char put to UART.
 * @retval The char put to UART.
 ************************************************************************************************************/
uint16_t SERIAL_PutChar(uint8_t ch)
{

  while ((UART2->SR & UART_ISR_TXF)); 
  UART2->BR = ch;	

  return ch;
}

/*********************************************************************************************************//**
 * @brief  Get char from UART.
 * @retval The char got from UART.
 ************************************************************************************************************/
uint16_t SERIAL_GetChar(void)
{

  while ((UART2->SR & UART_ISR_RXNE)==0); // Wait if Receive Holding register is empty
  return (UART2->BR);
}

/**
  * @}
  */


/**
  * @}
  */

/**
  * @}
  */

