/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stdio.h"
/** @addtogroup PT32Z192xx_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



	
	void Delay(int Count)
{
  while(Count--);
}

void LED_GPIO_Config(void)
{		
	/*һGPIO_InitTypeDef͵Ľṹ*/
	GPIO_InitTypeDef GPIO_InitStructure;
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	
	/*ģʽΪͨ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);		
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);	
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);
	/* رled	*/
	GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);		
	/* رled	*/
	GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	    
  /* رled	*/
	GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB10ΪUART2_TX,PB11ΪUART2_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource11, GPIO_AF_1);
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource10, GPIO_AF_1);
  GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_11,ENABLE);
	GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_10,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
	UART_InitStruct.FCPU = 24000000;
  UART_Init(UART2, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART2, ENABLE);
}

void EXTI_Key_Config(void)
{
  NVIC_InitTypeDef NVIC_InitStruct;

  NVIC_InitStruct.NVIC_IRQChannel = PC_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*ðõPC5жΪ½ش*/
	GPIO_TriTypeConfig(CMSDK_PC, GPIO_Pin_5, GPIOTI_Trigger_Rising);
  /*ʹܰõPC5ܽŵж*/
	GPIO_ITConfig(CMSDK_PC, GPIO_IT_ITE5, ENABLE);
}

int main(void)
{

 /* ʼRGBʵ */
  LED_GPIO_Config();
	/*ʼΪжģʽжϺжϷ*/
	EXTI_Key_Config();
	/*ʼUART2*/
  UART_Config();		
	printf("\r\n ӭʹ΢  PT32Z192xx  塣\r\n");
  printf("\r\n PT32Z192xx ˯ģʽ\r\n");
	
	printf("\r\n ˵\r\n");
	printf("\r\n 1.Ʊʾ˯״̬Ʊʾմ˯״̬\r\n");
	printf("\r\n 2.ʹ WFE ¼ѷʽͨ¼ѲҪʹNVICж\r\n");
	printf("\r\n 3.̼ؽMCUҪſԽ뵽Deepsleep\r\n");
	printf("\r\n 4.һʱԶ˯״̬˯״̬£ʹUSERKEY_PC5\r\n");
	printf("\r\n 5.ִһѭ\r\n");
	printf("\r\n ̵()->(˯ģʽ)->USERKEY->(ձ)\r\n");
	printf("\r\n 6.˯״̬£ҲֱͨSWDӿڣȥѽ̵Debug\r\n");
  /* Infinite loop */
  while (1)
  {
		printf("\r\nPT32Z192xxУ̵\r\n");	
		LED_GREEN;	
		Delay(0x3FFFFF);
		printf("\r\nģʽ,USERKEYɻ\r\n");
		Delay(0xFFF);
    /* ַָRGBʵɫ */
		/*ʹúָʾ˯״̬*/
		LED_RED;
		/*˯ģʽ*/
    /*ʹܰõPC5ܽŵж*/
		Power_DeepSleep(POWER_SLEEP_WFE);
		/*ȴжϻ  USERKEYж*/
		LED_BLUE;
		/*ѣָʾ*/
		printf("\r\n ˳˯ģʽ\r\n");
		Delay(0x500000);					

   } 		 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */



