/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include <stdio.h>
#include <stdlib.h>

#define PWM0_CH1_GPIO_Port               CMSDK_PA
#define PWM0_CH1_PinSource               GPIO_PinSource8
#define PWM0_CH1_Pin                     GPIO_Pin_8


#define PWM0_CH1N_GPIO_Port               CMSDK_PC
#define PWM0_CH1N_PinSource               GPIO_PinSource6
#define PWM0_CH1N_Pin                     GPIO_Pin_6

#define BKI_GPIO_Port               CMSDK_PA
#define BKI_PinSource               GPIO_PinSource12
#define BKI_Pin                     GPIO_Pin_12

#define            ADVANCE_TIM_PERIOD            (1024-1)
#define            ADVANCE_TIM_PSC               (67-1)
#define            ADVANCE_TIM_PULSE             (1-1)
#define            ADVANCE_TIM_DeadTime           0

/** @addtogroup PT32Z192xx_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void LED_GPIO_Config(void)
{		
  /*һGPIO_InitTypeDef͵Ľṹ*/
	GPIO_InitTypeDef GPIO_InitStructure;
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;
	/*ûմ*/
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	/*ģʽΪͨ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);			
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);	
	/*ѡҪƵGPIO*/
	GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;
	/*ÿ⺯ʼGPIO*/
	GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);
	/* رled	*/
	GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);		
	/* رled	*/
	GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	    
  /* رled	*/
	GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

static void PWM_GPIO_Config(void)
{	
  /* PA8ΪPWM */	
  GPIO_PinAFConfig(PWM0_CH1_GPIO_Port, PWM0_CH1_PinSource, GPIO_AF_2); 
  /* PC6ΪPWM_N */	
  GPIO_PinAFConfig(PWM0_CH1N_GPIO_Port, PWM0_CH1N_PinSource, GPIO_AF_2); 
	 /* PA12ΪBKIɲ */	
	GPIO_PinAFConfig(BKI_GPIO_Port, BKI_PinSource, GPIO_AF_2); 
	
}
static void PWM_Mode_Config(void)
{
  PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_OutputInitTypeDef OutInit;
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TMR0_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.CounterReload = ADVANCE_TIM_PERIOD;
	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = PWM_CNT_MODE_UP;
	/*رսģʽ*/
	TimeBaseInit.CounterDirRv_EN = PWM_CounterDirRv_DIS;
	/*ʼʱ*/
  PMW_TimeBaseInit(PWM0, &TimeBaseInit);
  /* ΪPWMͨΪ2ͨ*/
	OutInit.Channel =PWM_CH_1;
  /* ΪPWMģʽTCֵռձƥĴֵߵƽ*/	
	OutInit.OutputMode = COMPAER_MODE2;
	 /* ûʹ*/
  OutInit.ControlN = PWM_CHNCTL_ENABLE;
	/* ʱ*/
	OutInit.DeathTime = ADVANCE_TIM_DeadTime;
	/* PWMʱƽ״̬ɲʱԼPWMδʹ֮ǰƽ״̬ɲ󻥲ͨƽȻ*/	
	OutInit.IdleState = PWM_IDLE_LOW;
  /* PWMռձ P = (ADVANCE_TIM_PULSE+1) / (ADVANCE_TIM_PERIOD+1)*/	
	OutInit.CompareValue = ADVANCE_TIM_PULSE;                          
	/*ʼPWM*/	
	PWM_OutputInit(PWM0, &OutInit);
	/*ʹͨ1ƥж*/
  PWM_IntConfig(PWM0, PWM_INT_MR0, ENABLE);
	/*ɲʹ*/
	PWM_BreakInput_Cmd(PWM0,ENABLE);
	/*͵ƽɲ*/
	PWM_BKI_LevelConfig(PWM0,PWM_BKI_LOWLEVEL);
	/*ʹPWM*/	
	PWM_Cmd(PWM0, ENABLE);
}

void keypress(){
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = PC_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x01;
	NVIC_Init(&NVIC_InitStruct);
	
	GPIO_ITConfig(CMSDK_PC,GPIO_IT_ITE5,ENABLE);
	GPIO_TriTypeConfig(CMSDK_PC, GPIO_Pin_5,GPIOTI_Trigger_Falling);
}
/**
  * @brief  ʼPWM
  * @param  None
  * @retval None
  */
static void PWM_Ini(void)
{
  PWM_GPIO_Config();
  PWM_Mode_Config();	
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
	void Delay(int Count)
{
  while(Count--);
}

int main(void)
{

  LED_GPIO_Config();	

	/*PWMͨʼ*/
  PWM_Ini();
  GPIO_PullUpConfig(CMSDK_PA, GPIO_Pin_12, ENABLE);
  keypress();
	 while (1);
  /*PWM0_CH1ռձʱ䲻ϱ仯*/
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  while (1)
  {

  }
}
#endif

/**
  * @}
  */



