/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include <stdio.h>
/** @addtogroup PT32Z192xx_StdPeriph_Templates
  * @{
  */
	
#define PWM0_CH1_GPIO_Port               CMSDK_PB
#define PWM0_CH1_PinSource               GPIO_PinSource12
#define PWM0_CH1_Pin                     GPIO_Pin_12


/*PWM0ʱTCһ1us*/
#define            ADVANCE_TIM_PERIOD            60000
#define            ADVANCE_TIM_PSC               23
uint32_t occurred;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB10ΪUART2_TX,PB11ΪUART2_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource11, GPIO_AF_1);
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource10, GPIO_AF_1);
  GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_11,ENABLE);
	GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_10,ENABLE);
	/*ʼUART2*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D_P;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
	UART_InitStruct.FCPU = 24000000;
  UART_Init(UART2, &UART_InitStruct);
	/*UART2շ*/		
  UART_Cmd(UART2, ENABLE);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */


static void Capture_Mode_Config(void)
{
  /*ʹTIMER1NVIC*/
  NVIC_InitTypeDef NVIC_InitStruct;
  NVIC_InitStruct.NVIC_IRQChannel = TMR0_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/*TIMER1ͨ1زܴ*/
	PWM_RE_CaptureConfig(PWM0, PWM_CH_1, ENABLE);
	/*TIMER1ͨ1زжʹ*/
  PWM_IntConfig(PWM0, PWM_INT_CAP1, ENABLE);

	/*ʼTIMER1Ķʱ*/
  PWM_PrescalerConfig(PWM0, ADVANCE_TIM_PSC);
	PWM_SetCounterReload(PWM0, ADVANCE_TIM_PERIOD);

}

static void Capture_GPIO_Config(void)
{	
  /* PB12ΪPWM0벶 */	
  GPIO_PinAFConfig( PWM0_CH1_GPIO_Port,PWM0_CH1_PinSource,GPIO_AF_3);
	
}
static void Capture_Config(void)
{
  Capture_GPIO_Config();
	Capture_Mode_Config();
}


int main(void)
{

  occurred=0;

	/*ʼUART0*/
  UART_Config();
  /*ʼ*/
	Capture_Config();

  printf("\r\n ߼ʱ\r\n");
	printf("\r\n PB12ΪTIM0ͨCH1  \r\n  PB12뷽ӡ(С50KHz)\r\n");
	
  PWM_Cmd(PWM0, ENABLE);

  while (1)
  {
	 /*TIMER0жϺڴ¼*/

      if(PWM_GetFlagStatus(PWM0,PWM_FLAG_MR0))
	    {
			  PWM_ClearFlag(PWM0, PWM_FLAG_MR0);
    	  occurred++;

	    }
  } 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */



